diff --git a/gcc/tree-vect-loop.c b/gcc/tree-vect-loop.c
index 4ce721ed..55d7aaf 100644
--- a/gcc/tree-vect-loop.c
+++ b/gcc/tree-vect-loop.c
@@ -54,6 +54,7 @@ along with GCC; see the file COPYING3.  If not see
 #include "tree-vector-builder.h"
 #include "vec-perm-indices.h"
 #include "tree-eh.h"
+#include "optimization-records.h"
 
 /* Loop Vectorization Pass.
 
@@ -155,6 +156,56 @@ along with GCC; see the file COPYING3.  If not see
 
 static void vect_estimate_min_profitable_iters (loop_vec_info, int *, int *);
 
+bool thing_enabled_p ()
+{
+  return dump_enabled_p () || optimization_record_enabled_p ();
+}
+
+void vect_location_writeln (enum opt_record_kind kind,
+			    const char *fmt, ...)
+{
+  va_list ap;
+  va_start (ap, fmt);
+
+  if (dump_enabled_p ())
+    {
+      dump_flags_t flags = 0;
+      switch (kind)
+	{
+	default:
+	  gcc_unreachable ();
+	case OPT_RECORD_SUCCESS:
+	  gcc_unreachable ();
+	  //flags = ;
+	  break;
+	case OPT_RECORD_FAILURE:
+	  flags = MSG_MISSED_OPTIMIZATION;
+	  break;
+	case OPT_RECORD_REMARK:
+	  flags = MSG_NOTE;
+	  break;
+	}
+
+      dump_printf_loc_va (flags, vect_location, fmt, &ap);
+      dump_printf (flags, "\n");
+    }
+  va_end (ap);
+
+  va_start (ap, fmt);
+
+  if (optimization_record_enabled_p ())
+    {
+      if (vect_location_thing.m_loop != NULL)
+	maybe_record_optimization_va (kind, vect_location_thing.m_loop,
+				      fmt, &ap);
+      else
+	maybe_record_optimization_va (kind, vect_location_thing.m_stmt,
+				      fmt, &ap);
+    }
+
+  va_end (ap);
+}
+
 /* Function vect_determine_vectorization_factor
 
    Determine the vectorization factor (VF).  VF is the number of data elements
@@ -200,9 +251,9 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
   bool bool_result;
   auto_vec<stmt_vec_info> mask_producers;
 
-  if (dump_enabled_p ())
-    dump_printf_loc (MSG_NOTE, vect_location,
-                     "=== vect_determine_vectorization_factor ===\n");
+  if (thing_enabled_p ())
+    vect_location_writeln (OPT_RECORD_REMARK,
+                     "=== vect_determine_vectorization_factor ===");
 
   for (i = 0; i < nbbs; i++)
     {
@@ -213,9 +264,9 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
 	{
 	  phi = si.phi ();
 	  stmt_info = vinfo_for_stmt (phi);
-	  if (dump_enabled_p ())
+	  if (thing_enabled_p ())
 	    {
-	      dump_printf_loc (MSG_NOTE, vect_location, "==> examining phi: ");
+	      vect_location_writeln (OPT_RECORD_REMARK, "==> examining phi: ");
 	      dump_gimple_stmt (MSG_NOTE, TDF_SLIM, phi, 0);
 	    }
 
@@ -227,9 +278,9 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
 	      gcc_assert (!STMT_VINFO_VECTYPE (stmt_info));
               scalar_type = TREE_TYPE (PHI_RESULT (phi));
 
-	      if (dump_enabled_p ())
+	      if (thing_enabled_p ())
 		{
-		  dump_printf_loc (MSG_NOTE, vect_location,
+		  vect_location_writeln (OPT_RECORD_REMARK,
                                    "get vectype for scalar type:  ");
 		  dump_generic_expr (MSG_NOTE, TDF_SLIM, scalar_type);
                   dump_printf (MSG_NOTE, "\n");
@@ -238,9 +289,9 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
 	      vectype = get_vectype_for_scalar_type (scalar_type);
 	      if (!vectype)
 		{
-		  if (dump_enabled_p ())
+		  if (thing_enabled_p ())
 		    {
-		      dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+		      vect_location_writeln (OPT_RECORD_FAILURE,
                                        "not vectorized: unsupported "
                                        "data-type ");
 		      dump_generic_expr (MSG_MISSED_OPTIMIZATION, TDF_SLIM,
@@ -251,16 +302,16 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
 		}
 	      STMT_VINFO_VECTYPE (stmt_info) = vectype;
 
-	      if (dump_enabled_p ())
+	      if (thing_enabled_p ())
 		{
-		  dump_printf_loc (MSG_NOTE, vect_location, "vectype: ");
+		  vect_location_writeln (OPT_RECORD_REMARK, "vectype: ");
 		  dump_generic_expr (MSG_NOTE, TDF_SLIM, vectype);
                   dump_printf (MSG_NOTE, "\n");
 		}
 
-	      if (dump_enabled_p ())
+	      if (thing_enabled_p ())
 		{
-		  dump_printf_loc (MSG_NOTE, vect_location, "nunits = ");
+		  vect_location_writeln (OPT_RECORD_REMARK, "nunits = ");
 		  dump_dec (MSG_NOTE, TYPE_VECTOR_SUBPARTS (vectype));
 		  dump_printf (MSG_NOTE, "\n");
 		}
@@ -281,9 +332,9 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
 
           stmt_info = vinfo_for_stmt (stmt);
 
-	  if (dump_enabled_p ())
+	  if (thing_enabled_p ())
 	    {
-	      dump_printf_loc (MSG_NOTE, vect_location,
+	      vect_location_writeln (OPT_RECORD_REMARK,
                                "==> examining statement: ");
 	      dump_gimple_stmt (MSG_NOTE, TDF_SLIM, stmt, 0);
 	    }
@@ -302,17 +353,17 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
                 {
                   stmt = pattern_stmt;
                   stmt_info = vinfo_for_stmt (pattern_stmt);
-                  if (dump_enabled_p ())
+                  if (thing_enabled_p ())
                     {
-                      dump_printf_loc (MSG_NOTE, vect_location,
+                      vect_location_writeln (OPT_RECORD_REMARK,
                                        "==> examining pattern statement: ");
                       dump_gimple_stmt (MSG_NOTE, TDF_SLIM, stmt, 0);
                     }
                 }
               else
 	        {
-	          if (dump_enabled_p ())
-	            dump_printf_loc (MSG_NOTE, vect_location, "skip.\n");
+	          if (thing_enabled_p ())
+	            vect_location_writeln (OPT_RECORD_REMARK, "skip.\n");
                   gsi_next (&si);
 	          continue;
                 }
@@ -351,9 +402,9 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
 
 		  if (!gsi_end_p (pattern_def_si))
 		    {
-		      if (dump_enabled_p ())
+		      if (thing_enabled_p ())
 			{
-			  dump_printf_loc (MSG_NOTE, vect_location,
+			  vect_location_writeln (OPT_RECORD_REMARK,
                                            "==> examining pattern def stmt: ");
 			  dump_gimple_stmt (MSG_NOTE, TDF_SLIM,
                                             pattern_def_stmt, 0);
@@ -391,9 +442,9 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
 		    }
 		  continue;
 		}
-	      if (dump_enabled_p ())
+	      if (thing_enabled_p ())
 		{
-	          dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	          vect_location_writeln (OPT_RECORD_FAILURE,
                                    "not vectorized: irregular stmt.");
 		  dump_gimple_stmt (MSG_MISSED_OPTIMIZATION,  TDF_SLIM, stmt,
                                     0);
@@ -403,9 +454,9 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
 
 	  if (VECTOR_MODE_P (TYPE_MODE (gimple_expr_type (stmt))))
 	    {
-	      if (dump_enabled_p ())
+	      if (thing_enabled_p ())
 	        {
-	          dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	          vect_location_writeln (OPT_RECORD_FAILURE,
                                    "not vectorized: vector stmt in loop:");
 	          dump_gimple_stmt (MSG_MISSED_OPTIMIZATION, TDF_SLIM, stmt, 0);
 	        }
@@ -461,9 +512,9 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
 		    }
 		}
 
-	      if (dump_enabled_p ())
+	      if (thing_enabled_p ())
 		{
-		  dump_printf_loc (MSG_NOTE, vect_location,
+		  vect_location_writeln (OPT_RECORD_REMARK,
                                    "get vectype for scalar type:  ");
 		  dump_generic_expr (MSG_NOTE, TDF_SLIM, scalar_type);
                   dump_printf (MSG_NOTE, "\n");
@@ -471,9 +522,9 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
 	      vectype = get_vectype_for_scalar_type (scalar_type);
 	      if (!vectype)
 		{
-		  if (dump_enabled_p ())
+		  if (thing_enabled_p ())
 		    {
-		      dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+		      vect_location_writeln (OPT_RECORD_FAILURE,
                                        "not vectorized: unsupported "
                                        "data-type ");
 		      dump_generic_expr (MSG_MISSED_OPTIMIZATION, TDF_SLIM,
@@ -486,9 +537,9 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
 	      if (!bool_result)
 		STMT_VINFO_VECTYPE (stmt_info) = vectype;
 
-	      if (dump_enabled_p ())
+	      if (thing_enabled_p ())
 		{
-		  dump_printf_loc (MSG_NOTE, vect_location, "vectype: ");
+		  vect_location_writeln (OPT_RECORD_REMARK, "vectype: ");
 		  dump_generic_expr (MSG_NOTE, TDF_SLIM, vectype);
                   dump_printf (MSG_NOTE, "\n");
 		}
@@ -506,9 +557,9 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
 	      if (!bool_result)
 		scalar_type = vect_get_smallest_scalar_type (stmt, &dummy,
 							     &dummy);
-	      if (dump_enabled_p ())
+	      if (thing_enabled_p ())
 		{
-		  dump_printf_loc (MSG_NOTE, vect_location,
+		  vect_location_writeln (OPT_RECORD_REMARK,
 				   "get vectype for scalar type:  ");
 		  dump_generic_expr (MSG_NOTE, TDF_SLIM, scalar_type);
 		  dump_printf (MSG_NOTE, "\n");
@@ -517,9 +568,9 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
 	    }
 	  if (!vf_vectype)
 	    {
-	      if (dump_enabled_p ())
+	      if (thing_enabled_p ())
 		{
-		  dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+		  vect_location_writeln (OPT_RECORD_FAILURE,
                                    "not vectorized: unsupported data-type ");
 		  dump_generic_expr (MSG_MISSED_OPTIMIZATION, TDF_SLIM,
                                      scalar_type);
@@ -531,9 +582,9 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
 	  if (maybe_ne (GET_MODE_SIZE (TYPE_MODE (vectype)),
 			GET_MODE_SIZE (TYPE_MODE (vf_vectype))))
 	    {
-	      if (dump_enabled_p ())
+	      if (thing_enabled_p ())
 		{
-		  dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+		  vect_location_writeln (OPT_RECORD_FAILURE,
                                    "not vectorized: different sized vector "
                                    "types in statement, ");
 		  dump_generic_expr (MSG_MISSED_OPTIMIZATION, TDF_SLIM,
@@ -546,16 +597,16 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
 	      return false;
 	    }
 
-	  if (dump_enabled_p ())
+	  if (thing_enabled_p ())
 	    {
-	      dump_printf_loc (MSG_NOTE, vect_location, "vectype: ");
+	      vect_location_writeln (OPT_RECORD_REMARK, "vectype: ");
 	      dump_generic_expr (MSG_NOTE, TDF_SLIM, vf_vectype);
               dump_printf (MSG_NOTE, "\n");
 	    }
 
-	  if (dump_enabled_p ())
+	  if (thing_enabled_p ())
 	    {
-	      dump_printf_loc (MSG_NOTE, vect_location, "nunits = ");
+	      vect_location_writeln (OPT_RECORD_REMARK, "nunits = ");
 	      dump_dec (MSG_NOTE, TYPE_VECTOR_SUBPARTS (vf_vectype));
 	      dump_printf (MSG_NOTE, "\n");
 	    }
@@ -571,18 +622,18 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
     }
 
   /* TODO: Analyze cost. Decide if worth while to vectorize.  */
-  if (dump_enabled_p ())
+  if (thing_enabled_p ())
     {
-      dump_printf_loc (MSG_NOTE, vect_location, "vectorization factor = ");
+      vect_location_writeln (OPT_RECORD_REMARK, "vectorization factor = ");
       dump_dec (MSG_NOTE, vectorization_factor);
       dump_printf (MSG_NOTE, "\n");
     }
 
   if (known_le (vectorization_factor, 1U))
     {
-      if (dump_enabled_p ())
-        dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
-                         "not vectorized: unsupported data-type\n");
+      if (thing_enabled_p ())
+        vect_location_writeln (OPT_RECORD_FAILURE,
+			       "not vectorized: unsupported data-type");
       return false;
     }
   LOOP_VINFO_VECT_FACTOR (loop_vinfo) = vectorization_factor;
@@ -603,9 +654,9 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
 
 	  if (!mask_type)
 	    {
-	      if (dump_enabled_p ())
-		dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
-				 "not vectorized: unsupported mask\n");
+	      if (thing_enabled_p ())
+		vect_location_writeln (OPT_RECORD_FAILURE,
+				       "not vectorized: unsupported mask");
 	      return false;
 	    }
 	}
@@ -621,9 +672,9 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
 	      if (!vect_is_simple_use (rhs, mask_producers[i]->vinfo,
 				       &def_stmt, &dt, &vectype))
 		{
-		  if (dump_enabled_p ())
+		  if (thing_enabled_p ())
 		    {
-		      dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+		      vect_location_writeln (OPT_RECORD_FAILURE,
 				       "not vectorized: can't compute mask type "
 				       "for statement, ");
 		      dump_gimple_stmt (MSG_MISSED_OPTIMIZATION,  TDF_SLIM, stmt,
@@ -643,9 +694,9 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
 	      else if (maybe_ne (TYPE_VECTOR_SUBPARTS (mask_type),
 				 TYPE_VECTOR_SUBPARTS (vectype)))
 		{
-		  if (dump_enabled_p ())
+		  if (thing_enabled_p ())
 		    {
-		      dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+		      vect_location_writeln (OPT_RECORD_FAILURE,
 				       "not vectorized: different sized masks "
 				       "types in statement, ");
 		      dump_generic_expr (MSG_MISSED_OPTIMIZATION, TDF_SLIM,
@@ -660,9 +711,9 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
 	      else if (VECTOR_BOOLEAN_TYPE_P (mask_type)
 		       != VECTOR_BOOLEAN_TYPE_P (vectype))
 		{
-		  if (dump_enabled_p ())
+		  if (thing_enabled_p ())
 		    {
-		      dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+		      vect_location_writeln (OPT_RECORD_FAILURE,
 				       "not vectorized: mixed mask and "
 				       "nonmask vector types in statement, ");
 		      dump_generic_expr (MSG_MISSED_OPTIMIZATION, TDF_SLIM,
@@ -690,9 +741,9 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
 	 if-conversion.  */
       if (!mask_type)
 	{
-	  if (dump_enabled_p ())
+	  if (thing_enabled_p ())
 	    {
-	      dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	      vect_location_writeln (OPT_RECORD_FAILURE,
 			       "not vectorized: can't compute mask type "
 			       "for statement, ");
 	      dump_gimple_stmt (MSG_MISSED_OPTIMIZATION,  TDF_SLIM, stmt,
@@ -735,9 +786,9 @@ vect_is_simple_iv_evolution (unsigned loop_nb, tree access_fn, tree * init,
   step_expr = evolution_part;
   init_expr = unshare_expr (initial_condition_in_loop_num (access_fn, loop_nb));
 
-  if (dump_enabled_p ())
+  if (thing_enabled_p ())
     {
-      dump_printf_loc (MSG_NOTE, vect_location, "step: ");
+      vect_location_writeln (OPT_RECORD_REMARK, "step: ");
       dump_generic_expr (MSG_NOTE, TDF_SLIM, step_expr);
       dump_printf (MSG_NOTE, ",  init: ");
       dump_generic_expr (MSG_NOTE, TDF_SLIM, init_expr);
@@ -757,9 +808,9 @@ vect_is_simple_iv_evolution (unsigned loop_nb, tree access_fn, tree * init,
       && (TREE_CODE (step_expr) != REAL_CST
 	  || !flag_associative_math))
     {
-      if (dump_enabled_p ())
-        dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
-                         "step unknown.\n");
+      if (thing_enabled_p ())
+        vect_location_writeln (OPT_RECORD_FAILURE,
+			       "step unknown");
       return false;
     }
 
@@ -782,9 +833,9 @@ vect_analyze_scalar_cycles_1 (loop_vec_info loop_vinfo, struct loop *loop)
   gphi_iterator gsi;
   bool double_reduc;
 
-  if (dump_enabled_p ())
-    dump_printf_loc (MSG_NOTE, vect_location,
-                     "=== vect_analyze_scalar_cycles ===\n");
+  if (thing_enabled_p ())
+    vect_location_writeln (OPT_RECORD_REMARK,
+			   "=== vect_analyze_scalar_cycles ===");
 
   /* First - identify all inductions.  Reduction detection assumes that all the
      inductions have been identified, therefore, this order must not be
@@ -796,9 +847,9 @@ vect_analyze_scalar_cycles_1 (loop_vec_info loop_vinfo, struct loop *loop)
       tree def = PHI_RESULT (phi);
       stmt_vec_info stmt_vinfo = vinfo_for_stmt (phi);
 
-      if (dump_enabled_p ())
+      if (thing_enabled_p ())
 	{
-	  dump_printf_loc (MSG_NOTE, vect_location, "Analyze phi: ");
+	  vect_location_writeln (OPT_RECORD_REMARK, "Analyze phi: ");
 	  dump_gimple_stmt (MSG_NOTE, TDF_SLIM, phi, 0);
 	}
 
@@ -814,9 +865,9 @@ vect_analyze_scalar_cycles_1 (loop_vec_info loop_vinfo, struct loop *loop)
       if (access_fn)
 	{
 	  STRIP_NOPS (access_fn);
-	  if (dump_enabled_p ())
+	  if (thing_enabled_p ())
 	    {
-	      dump_printf_loc (MSG_NOTE, vect_location,
+	      vect_location_writeln (OPT_RECORD_REMARK,
                                "Access function of PHI: ");
 	      dump_generic_expr (MSG_NOTE, TDF_SLIM, access_fn);
               dump_printf (MSG_NOTE, "\n");
@@ -840,8 +891,8 @@ vect_analyze_scalar_cycles_1 (loop_vec_info loop_vinfo, struct loop *loop)
 		  != NULL_TREE);
       gcc_assert (STMT_VINFO_LOOP_PHI_EVOLUTION_PART (stmt_vinfo) != NULL_TREE);
 
-      if (dump_enabled_p ())
-	dump_printf_loc (MSG_NOTE, vect_location, "Detected induction.\n");
+      if (thing_enabled_p ())
+	vect_location_writeln (OPT_RECORD_REMARK, "Detected induction");
       STMT_VINFO_DEF_TYPE (stmt_vinfo) = vect_induction_def;
     }
 
@@ -854,9 +905,9 @@ vect_analyze_scalar_cycles_1 (loop_vec_info loop_vinfo, struct loop *loop)
       stmt_vec_info stmt_vinfo = vinfo_for_stmt (phi);
       gimple *reduc_stmt;
 
-      if (dump_enabled_p ())
+      if (thing_enabled_p ())
         {
-          dump_printf_loc (MSG_NOTE, vect_location, "Analyze phi: ");
+          vect_location_writeln (OPT_RECORD_REMARK, "Analyze phi: ");
           dump_gimple_stmt (MSG_NOTE, TDF_SLIM, phi, 0);
         }
 
@@ -869,9 +920,9 @@ vect_analyze_scalar_cycles_1 (loop_vec_info loop_vinfo, struct loop *loop)
         {
           if (double_reduc)
             {
-              if (dump_enabled_p ())
-                dump_printf_loc (MSG_NOTE, vect_location,
-				 "Detected double reduction.\n");
+              if (thing_enabled_p ())
+                vect_location_writeln (OPT_RECORD_REMARK,
+				       "Detected double reduction");
 
               STMT_VINFO_DEF_TYPE (stmt_vinfo) = vect_double_reduction_def;
               STMT_VINFO_DEF_TYPE (vinfo_for_stmt (reduc_stmt)) =
@@ -881,9 +932,9 @@ vect_analyze_scalar_cycles_1 (loop_vec_info loop_vinfo, struct loop *loop)
             {
               if (loop != LOOP_VINFO_LOOP (loop_vinfo))
                 {
-                  if (dump_enabled_p ())
-                    dump_printf_loc (MSG_NOTE, vect_location,
-				     "Detected vectorizable nested cycle.\n");
+                  if (thing_enabled_p ())
+                    vect_location_writeln (OPT_RECORD_REMARK,
+					   "Detected vectorizable nested cycle");
 
                   STMT_VINFO_DEF_TYPE (stmt_vinfo) = vect_nested_cycle;
                   STMT_VINFO_DEF_TYPE (vinfo_for_stmt (reduc_stmt)) =
@@ -891,9 +942,9 @@ vect_analyze_scalar_cycles_1 (loop_vec_info loop_vinfo, struct loop *loop)
                 }
               else
                 {
-                  if (dump_enabled_p ())
-                    dump_printf_loc (MSG_NOTE, vect_location,
-				     "Detected reduction.\n");
+                  if (thing_enabled_p ())
+                    vect_location_writeln (OPT_RECORD_REMARK,
+					   "Detected reduction");
 
                   STMT_VINFO_DEF_TYPE (stmt_vinfo) = vect_reduction_def;
                   STMT_VINFO_DEF_TYPE (vinfo_for_stmt (reduc_stmt)) =
@@ -907,9 +958,9 @@ vect_analyze_scalar_cycles_1 (loop_vec_info loop_vinfo, struct loop *loop)
             }
         }
       else
-        if (dump_enabled_p ())
-          dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
-			   "Unknown def-use cycle pattern.\n");
+        if (thing_enabled_p ())
+          vect_location_writeln (OPT_RECORD_FAILURE,
+				 "Unknown def-use cycle pattern");
     }
 }
 
@@ -1029,9 +1080,9 @@ vect_get_loop_niters (struct loop *loop, tree *assumptions,
   *assumptions = boolean_true_node;
   *number_of_iterationsm1 = chrec_dont_know;
   *number_of_iterations = chrec_dont_know;
-  if (dump_enabled_p ())
-    dump_printf_loc (MSG_NOTE, vect_location,
-		     "=== get_loop_niters ===\n");
+  if (thing_enabled_p ())
+    vect_location_writeln (OPT_RECORD_REMARK,
+			   "=== get_loop_niters ===");
 
   if (!exit)
     return cond;
@@ -1470,9 +1521,9 @@ vect_analyze_loop_form_1 (struct loop *loop, gcond **loop_cond,
 			  tree *assumptions, tree *number_of_iterationsm1,
 			  tree *number_of_iterations, gcond **inner_loop_cond)
 {
-  if (dump_enabled_p ())
-    dump_printf_loc (MSG_NOTE, vect_location,
-		     "=== vect_analyze_loop_form ===\n");
+  if (thing_enabled_p ())
+    vect_location_writeln (OPT_RECORD_REMARK,
+			   "=== vect_analyze_loop_form ===");
 
   /* Different restrictions apply when we are considering an inner-most loop,
      vs. an outer (nested) loop.
@@ -1494,17 +1545,17 @@ vect_analyze_loop_form_1 (struct loop *loop, gcond **loop_cond,
 
       if (loop->num_nodes != 2)
         {
-          if (dump_enabled_p ())
-            dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
-			     "not vectorized: control flow in loop.\n");
+          if (thing_enabled_p ())
+            vect_location_writeln (OPT_RECORD_FAILURE,
+				   "not vectorized: control flow in loop");
           return false;
         }
 
       if (empty_block_p (loop->header))
 	{
-	  if (dump_enabled_p ())
-	    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
-			     "not vectorized: empty loop.\n");
+	  if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_FAILURE,
+				   "not vectorized: empty loop");
 	  return false;
 	}
     }
@@ -1532,17 +1583,17 @@ vect_analyze_loop_form_1 (struct loop *loop, gcond **loop_cond,
 
       if ((loop->inner)->inner || (loop->inner)->next)
 	{
-	  if (dump_enabled_p ())
-	    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
-			     "not vectorized: multiple nested loops.\n");
+	  if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_FAILURE,
+				   "not vectorized: multiple nested loops");
 	  return false;
 	}
 
       if (loop->num_nodes != 5)
         {
-	  if (dump_enabled_p ())
-	    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
-			     "not vectorized: control flow in loop.\n");
+	  if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_FAILURE,
+				   "not vectorized: control flow in loop");
 	  return false;
         }
 
@@ -1551,9 +1602,9 @@ vect_analyze_loop_form_1 (struct loop *loop, gcond **loop_cond,
 	  || !single_exit (innerloop)
 	  || single_exit (innerloop)->dest != EDGE_PRED (loop->latch, 0)->src)
 	{
-	  if (dump_enabled_p ())
-	    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
-			     "not vectorized: unsupported outerloop form.\n");
+	  if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_FAILURE,
+				   "not vectorized: unsupported outerloop form");
 	  return false;
 	}
 
@@ -1566,37 +1617,37 @@ vect_analyze_loop_form_1 (struct loop *loop, gcond **loop_cond,
 	     loop.  */
 	  || !integer_onep (inner_assumptions))
 	{
-	  if (dump_enabled_p ())
-            dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
-			     "not vectorized: Bad inner loop.\n");
+	  if (thing_enabled_p ())
+            vect_location_writeln (OPT_RECORD_FAILURE,
+				   "not vectorized: bad inner loop");
 	  return false;
 	}
 
       if (!expr_invariant_in_loop_p (loop, inner_niter))
 	{
-	  if (dump_enabled_p ())
-	    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
-			     "not vectorized: inner-loop count not"
-                             " invariant.\n");
+	  if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_FAILURE,
+				   "not vectorized: inner-loop count not"
+				   " invariant");
 	  return false;
 	}
 
-      if (dump_enabled_p ())
-        dump_printf_loc (MSG_NOTE, vect_location,
-			 "Considering outer-loop vectorization.\n");
+      if (thing_enabled_p ())
+        vect_location_writeln (OPT_RECORD_REMARK,
+			       "Considering outer-loop vectorization");
     }
 
   if (!single_exit (loop)
       || EDGE_COUNT (loop->header->preds) != 2)
     {
-      if (dump_enabled_p ())
+      if (thing_enabled_p ())
         {
           if (!single_exit (loop))
-	    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
-			     "not vectorized: multiple exits.\n");
+	    vect_location_writeln (OPT_RECORD_FAILURE,
+			     "not vectorized: multiple exits");
           else if (EDGE_COUNT (loop->header->preds) != 2)
-	    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
-			     "not vectorized: too many incoming edges.\n");
+	    vect_location_writeln (OPT_RECORD_FAILURE,
+				   "not vectorized: too many incoming edges");
         }
       return false;
     }
@@ -1608,9 +1659,9 @@ vect_analyze_loop_form_1 (struct loop *loop, gcond **loop_cond,
   if (!empty_block_p (loop->latch)
       || !gimple_seq_empty_p (phi_nodes (loop->latch)))
     {
-      if (dump_enabled_p ())
-	dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
-			 "not vectorized: latch block not empty.\n");
+      if (thing_enabled_p ())
+	vect_location_writeln (OPT_RECORD_FAILURE,
+			       "not vectorized: latch block not empty");
       return false;
     }
 
@@ -1618,9 +1669,9 @@ vect_analyze_loop_form_1 (struct loop *loop, gcond **loop_cond,
   edge e = single_exit (loop);
   if (e->flags & EDGE_ABNORMAL)
     {
-      if (dump_enabled_p ())
-	dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
-			 "not vectorized: abnormal loop exit edge.\n");
+      if (thing_enabled_p ())
+	vect_location_writeln (OPT_RECORD_FAILURE,
+			       "not vectorized: abnormal loop exit edge");
       return false;
     }
 
@@ -1628,9 +1679,9 @@ vect_analyze_loop_form_1 (struct loop *loop, gcond **loop_cond,
 				     number_of_iterationsm1);
   if (!*loop_cond)
     {
-      if (dump_enabled_p ())
-	dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
-			 "not vectorized: complicated exit condition.\n");
+      if (thing_enabled_p ())
+	vect_location_writeln (OPT_RECORD_FAILURE,
+			       "not vectorized: complicated exit condition");
       return false;
     }
 
@@ -1638,18 +1689,18 @@ vect_analyze_loop_form_1 (struct loop *loop, gcond **loop_cond,
       || !*number_of_iterations
       || chrec_contains_undetermined (*number_of_iterations))
     {
-      if (dump_enabled_p ())
-	dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
-			 "not vectorized: number of iterations cannot be "
-			 "computed.\n");
+      if (thing_enabled_p ())
+	vect_location_writeln (OPT_RECORD_FAILURE,
+			       "not vectorized: number of iterations cannot be "
+			       "computed");
       return false;
     }
 
   if (integer_zerop (*number_of_iterations))
     {
-      if (dump_enabled_p ())
-	dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
-			 "not vectorized: number of iterations = 0.\n");
+      if (thing_enabled_p ())
+	vect_location_writeln (OPT_RECORD_FAILURE,
+			       "not vectorized: number of iterations = 0");
       return false;
     }
 
@@ -1689,9 +1740,9 @@ vect_analyze_loop_form (struct loop *loop)
 
   if (!LOOP_VINFO_NITERS_KNOWN_P (loop_vinfo))
     {
-      if (dump_enabled_p ())
+      if (thing_enabled_p ())
         {
-          dump_printf_loc (MSG_NOTE, vect_location,
+          vect_location_writeln (OPT_RECORD_REMARK,
 			   "Symbolic number of iterations is ");
 	  dump_generic_expr (MSG_NOTE, TDF_DETAILS, number_of_iterations);
           dump_printf (MSG_NOTE, "\n");
@@ -1722,9 +1773,9 @@ vect_update_vf_for_slp (loop_vec_info loop_vinfo)
   poly_uint64 vectorization_factor;
   int i;
 
-  if (dump_enabled_p ())
-    dump_printf_loc (MSG_NOTE, vect_location,
-		     "=== vect_update_vf_for_slp ===\n");
+  if (thing_enabled_p ())
+    vect_location_writeln (OPT_RECORD_REMARK,
+			   "=== vect_update_vf_for_slp ===");
 
   vectorization_factor = LOOP_VINFO_VECT_FACTOR (loop_vinfo);
   gcc_assert (known_ne (vectorization_factor, 0U));
@@ -1759,14 +1810,14 @@ vect_update_vf_for_slp (loop_vec_info loop_vinfo)
 
   if (only_slp_in_loop)
     {
-      dump_printf_loc (MSG_NOTE, vect_location,
-		       "Loop contains only SLP stmts\n");
+      vect_location_writeln (OPT_RECORD_REMARK,
+			     "Loop contains only SLP stmts");
       vectorization_factor = LOOP_VINFO_SLP_UNROLLING_FACTOR (loop_vinfo);
     }
   else
     {
-      dump_printf_loc (MSG_NOTE, vect_location,
-		       "Loop contains SLP and non-SLP stmts\n");
+      vect_location_writeln (OPT_RECORD_REMARK,
+			     "Loop contains SLP and non-SLP stmts");
       /* Both the vectorization factor and unroll factor have the form
 	 current_vector_size * X for some rational X, so they must have
 	 a common multiple.  */
@@ -1776,9 +1827,9 @@ vect_update_vf_for_slp (loop_vec_info loop_vinfo)
     }
 
   LOOP_VINFO_VECT_FACTOR (loop_vinfo) = vectorization_factor;
-  if (dump_enabled_p ())
+  if (thing_enabled_p ())
     {
-      dump_printf_loc (MSG_NOTE, vect_location,
+      vect_location_writeln (OPT_RECORD_REMARK,
 		       "Updating vectorization factor to ");
       dump_dec (MSG_NOTE, vectorization_factor);
       dump_printf (MSG_NOTE, ".\n");
@@ -1827,9 +1878,9 @@ vect_analyze_loop_operations (loop_vec_info loop_vinfo)
   bool need_to_vectorize = false;
   bool ok;
 
-  if (dump_enabled_p ())
-    dump_printf_loc (MSG_NOTE, vect_location,
-		     "=== vect_analyze_loop_operations ===\n");
+  if (thing_enabled_p ())
+    vect_location_writeln (OPT_RECORD_REMARK,
+			   "=== vect_analyze_loop_operations ===");
 
   for (i = 0; i < nbbs; i++)
     {
@@ -1842,9 +1893,9 @@ vect_analyze_loop_operations (loop_vec_info loop_vinfo)
           ok = true;
 
           stmt_info = vinfo_for_stmt (phi);
-          if (dump_enabled_p ())
+          if (thing_enabled_p ())
             {
-              dump_printf_loc (MSG_NOTE, vect_location, "examining phi: ");
+              vect_location_writeln (OPT_RECORD_REMARK, "examining phi: ");
               dump_gimple_stmt (MSG_NOTE, TDF_SLIM, phi, 0);
             }
 	  if (virtual_operand_p (gimple_phi_result (phi)))
@@ -1861,10 +1912,10 @@ vect_analyze_loop_operations (loop_vec_info loop_vinfo)
               if (STMT_VINFO_LIVE_P (stmt_info)
 		  && !vect_active_double_reduction_p (stmt_info))
                 {
-                  if (dump_enabled_p ())
-		    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
-				     "Unsupported loop-closed phi in "
-				     "outer-loop.\n");
+                  if (thing_enabled_p ())
+		    vect_location_writeln (OPT_RECORD_FAILURE,
+					   "Unsupported loop-closed phi in "
+					   "outer-loop");
                   return false;
                 }
 
@@ -1905,9 +1956,9 @@ vect_analyze_loop_operations (loop_vec_info loop_vinfo)
               && STMT_VINFO_DEF_TYPE (stmt_info) != vect_induction_def)
             {
               /* A scalar-dependence cycle that we don't support.  */
-              if (dump_enabled_p ())
-		dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
-				 "not vectorized: scalar dependence cycle.\n");
+              if (thing_enabled_p ())
+		vect_location_writeln (OPT_RECORD_FAILURE,
+				       "not vectorized: scalar dependence cycle");
               return false;
             }
 
@@ -1931,9 +1982,9 @@ vect_analyze_loop_operations (loop_vec_info loop_vinfo)
 
           if (!ok)
             {
-              if (dump_enabled_p ())
+              if (thing_enabled_p ())
                 {
-		  dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+		  vect_location_writeln (OPT_RECORD_FAILURE,
 				   "not vectorized: relevant phi not "
 				   "supported: ");
                   dump_gimple_stmt (MSG_MISSED_OPTIMIZATION, TDF_SLIM, phi, 0);
